<template>
  <div
    class="forgot-password"
  >
    <div class="background" />
    <section
      style="background-color: transparent;width:30%;position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);"
    >
      <b-image
        src="/images/logo128x128.png"
        alt="A random image"
        class="is-128x128 mb-3"
        style="margin:auto"
        rounded
      />
      <div
        class="box is-shadowless"
        style="border-radius:10px;border:solid;border-color:transparent;"
      >
        <h3 class="title has-text-centered has-text-primary">
          Reset Password
        </h3>
        <ValidationObserver v-slot="{ handleSubmit }">
          <ValidationProvider
            v-slot="{ errors }"
            rules="required|email"
            name="Email"
          >
            <b-field
              label="Email"
              :type="{ 'is-danger': errors[0] }"
              :message="errors"
              class="mb-5"
            >
              <b-input
                v-model="email"
                icon-right="user"
                placeholder="Email"
              />
            </b-field>
          </ValidationProvider>
          <ValidationProvider
            v-slot="{ errors }"
            rules="required"
            name="Password"
          >
            <b-field
              label="New Password"
              :type="{ 'is-danger': errors[0] }"
              :message="errors"
              class="mb-5"
            >
              <b-input
                v-model="password"
                type="password"
                placeholder="New Password"
                password-reveal
              />
            </b-field>
          </ValidationProvider>
          <ValidationProvider
            v-slot="{ errors }"
            rules="required"
            name="Password"
          >
            <b-field
              label="New Password Confirmation"
              :type="{ 'is-danger': errors[0] }"
              :message="errors"
              class="mb-5"
            >
              <b-input
                v-model="passwordConfirmation"
                type="password"
                placeholder="New Password Confirmation"
                password-reveal
              />
            </b-field>
          </ValidationProvider>
          <div class="has-text-centered">
            <b-button
              class="button is-primary"
              expanded
              @click="handleSubmit(resetPassword)"
            >
              Reset Password
            </b-button>
          </div>
        </ValidationObserver>
      </div>
    </section>
  </div>
</template>
<script>
export default {
  components: {},
  data () {
    return {
      email: '',
      password: '',
      passwordConfirmation: '',
      token: ''
    }
  },
  methods: {
    resetPassword: function () {
      const email = this.email
      const password = this.password
      const passwordConfirmation = this.passwordConfirmation

      this.$store
        .dispatch('resetPassword', { token: this.$route.params.token, email, password, passwordConfirmation })
        .then(() => {
          this.$buefy.toast.open({
            message: 'Reset Password Successful',
            type: 'is-success'
          })
          this.$router.push({ path: '/login' })
        })
        .catch(() => {
          this.$buefy.toast.open({
            message: 'Failed Reset Password',
            type: 'is-danger'
          })
        })
    }
  }
}
</script>
<style scoped>
.forgot-password{
  min-height:100vh;
}
.background{
  position:absolute;
  background-image:url("/images/background.jpg");
  width: 100%;
  height:100%;
  -webkit-background-size: cover;
  -moz-background-size: cover;
  -o-background-size: cover;
  background-size: cover;
  overflow:hidden
}
</style>
